﻿Type=Service
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	Dim rv As RemoteViews
'	Dim imageFiles() As String
'	imageFiles = Array As String("player_button_next.png", "player_button_pause.png", _
'		"player_button_play.png", "player_button_stop.png")
'	Dim currentImage As Int
	
	Dim alarmInfo As Alarm


' We are setting the base panel size to 294x72. This is the recommended size for a 4x1 cells widget.

End Sub
Sub Service_Create
	
	' Configure the homescreen widget. We let it update every 1 hour here. This is
	' normally not necessary but I want to be sure that the clock restarts if there
	' is any problem.
	rv = ConfigureHomeWidget("widget", "rv", 30, "Alarm Times",True)
	
	
	'Set the widget to update every 60 minutes.
	'rv = ConfigureHomeWidget("L1", "rv", 60, "Hello Widget")
End Sub

Sub Service_Start (StartingIntent As Intent)
	' If a widget is removed from homescreen we don't need to do anything
	If StartingIntent.Action = "android.appwidget.action.APPWIDGET_DELETED" Then Return

	' Handle the widget events (RequestUpdate and Disabled)
	If rv.HandleWidgetEvents(StartingIntent) = False Then
		' If the action is not handled by HandleWidgetEvents() then we
		' probably were called by StartService() or StartServiceAt().
		' So just update the widget.
		rv_RequestUpdate
	End If
	
	' We have to be sure that we do not start the service
	' again if all widgets are removed from homescreen
	If StartingIntent.Action <> "android.appwidget.action.APPWIDGET_DISABLED" Then
		StartServiceAt("", TimeToNextMinute + (4 * DateTime.TicksPerMinute) , False)
	End If


End Sub


Sub rv_RequestUpdate
	Dim alarmInfo As Alarm 
	' Just update the time on the widget
	Dim emsak,fajr,shorog,dohr,asr,maghrib,esha As String
	
	'DateTime.TimeFormat = "HH:mm"
	alarmInfo.SetDateTimeFormat(False)
	
	Dim alarms As Map = alarmInfo.GetTodaysAlarm(alarmInfo.Now )
	
		 emsak  	= alarms.Get("emsak")
		 fajr  		= alarms.Get("fajr")  
		 shorog 	= alarms.Get("shorog")  
		 dohr  		= alarms.Get("dohr")  
		 asr  		= alarms.Get("asr")  
		 maghrib	= alarms.Get("maghrib")  
		 esha  		= alarms.Get("esha")  

	
	rv.SetText("lblemsak", emsak )
	rv.SetText("lblfajr",  fajr)
	rv.SetText("lbldohr", dohr )
	rv.SetText("lblasr",asr  )
	rv.SetText("lblmaghrib", maghrib )
	rv.SetText("lblesha", esha )
	
	rv.UpdateWidget
End Sub

'
'Sub rv_RequestUpdate
'	SetTime
'	rv.UpdateWidget
'End Sub

Sub rv_Disabled
	' If all widgets are removed from homescreen cancel the next schedule and
	' stop the service
	CancelScheduledService("")
	StopService("")
End Sub
'
'Sub rv_Disabled
'	StopService("")
'End Sub

Sub Service_Destroy

End Sub


Sub TimeToNextMinute As Long
	Dim ret As Long

	ret = DateTime.Now + DateTime.TicksPerMinute
	ret = ret - (ret Mod DateTime.TicksPerMinute)	
	Return ret
End Sub

'
'Sub SetTime
'	rv.SetText("Label1", DateTime.Time(DateTime.Now))
'End Sub
'
'Sub ImageView1_Click
'	currentImage = (currentImage + 1) Mod imageFiles.Length
'	rv.SetImage("ImageView1", LoadBitmap(File.DirAssets, imageFiles(currentImage)))
'	rv.SetProgress("ProgressBar1", 100 * (currentImage + 1) / imageFiles.Length)
'	SetTime
'	rv.UpdateWidget
'End Sub


